<template>
  <div class="container">
    <base-dialog v-if="inputIsInvalid" title="InvalidInput">
      <template #default>
        <p>Unfortunetly, minimum one of your input is invalid.</p>
        <p>Please check all fields.</p>
      </template>
      <template #actions>
        <button @click="confirmError">Okay</button>
      </template>
    </base-dialog>
    <base-card>
      <form @submit.prevent="submitData">
        <div class="form-control">
          <label for="title">Title</label>
          <input
            id="title"
            name="title"
            type="text"
            ref="titleInput"
            :value="$attrs.title"
          />
        </div>
        <div class="form-control">
          <label for="description">Description</label>
          <textarea
            id="description"
            name="description"
            rows="3"
            ref="descInput"
            v-model="$attrs.description"
          ></textarea>
        </div>
        <div class="form-control">
          <label for="link">Link <span>(optional)</span></label>
          <input
            id="link"
            name="link"
            type="url"
            ref="linkInput"
            :value="$attrs.link"
          />
        </div>
        <div class="btns">
          <button type="submit">Edit Resource</button>
          <button @click="cancel">Cancel</button>
        </div>
      </form>
    </base-card>
  </div>
</template>

<script>
export default {
  inject: ["editResource"],
  data() {
    return {
      id: this.$refs.id,
      inputIsInvalid: false,
    };
  },
  methods: {
    cancel() {
      this.$emit("cancel");
    },
    submitData() {
      console.log("id w submitData: ", this.$attrs.id);
      const id = this.$attrs.id;
      const enteredTitle = this.$refs.titleInput.value;
      const enteredDescription = this.$refs.descInput.value;
      const enteredUrl = this.$refs.linkInput.value;
      if (enteredTitle.trim() === "" || enteredDescription.trim() === "") {
        this.inputIsInvalid = true;
        return;
      } else {
        this.editResource(id, enteredTitle, enteredDescription, enteredUrl);
        this.cancel();
      }
    },
    confirmError() {
      this.inputIsInvalid = false;
    },
  },
};
</script>

<style scoped>
.container {
  position: fixed;
  top: 0;
  left: 0;
  height: 100vh;
  width: 100vw;
  background-color: rgba(0, 0, 0, 0.75);
  z-index: 10;
}

label {
  font-weight: bold;
  display: block;
  margin-bottom: 0.5rem;
}
label span {
  font-weight: normal;
  font-size: 0.7rem;
}
input,
textarea {
  display: block;
  width: 100%;
  max-width: 100%;
  min-width: 100%;
  font: inherit;
  padding: 0.15rem;
  border: 1px solid #ccc;
}

input:focus,
textarea:focus {
  outline: none;
  border-color: #3a0061;
  background-color: #f7ebff;
}

.form-control {
  margin: 1rem 0;
}
button {
  padding: 0.75rem 1.5rem;
  font-family: inherit;
  background-color: #3a0061;
  border: 1px solid #3a0061;
  color: white;
  cursor: pointer;
  transition: 0.2s;
}
.btns {
  display: flex;
  justify-content: space-around;
}
</style>
